const qgRequire = window._global.requireModule
const systemStorage = qgRequire('@module/system.storage')
const systemFetch = qgRequire('@module/system.fetch')
var adService = null
var prodUrl = 'https://api.h5game.g.mi.com/stat'
// 兼容广告模块加载位置
try{
	adService = qgRequire('@module/service.internal.ad')
	if(!adService){
		console.warn('@module/service.internal.ad does not exist')
		adService = qgRequire('@module/service.ad')
	}
}catch(e){
	// console.log('catch exception 头 @module/service.ad')
	adService = qgRequire('@module/service.ad')
}

console.log("shellSdk begin +++++++++++++++++++++++++")
function setCookie (key, value, expireDays) {
	if (key) {
		var Days = 30;
		var exp = new Date();
		exp.setTime(exp.getTime() + 60 * 20000000);//过期时间 2分钟
		document.cookie = key + '=' + value+ ";expires=" + exp.toGMTString()+';domain=.mi.com; path=/'
	}
}


/**
 * 处理请求参数
 * @param data
 * @returns {string}
 */
function formatParams(data) {
  const arr = []
  for (const name in data) {
    arr.push(name + '=' + data[name])
  }
  return arr.join('&')
}
const sFetch = {
  get(url, data) {
    return new Promise((resolve, reject) => {
      systemFetch.fetch({
        url: url,
        method: 'GET',
        data: data,
        success: function(data) {
          if (typeof data === 'string') {
            resolve(JSON.parse(data))
          } else if (typeof data === 'object') {
            resolve(data)
          }
        },
        fail: function(data, code) {
          console.log(`handling fail, code = ${code}`, data)
          reject(data)
        }
      })
    })
  },
  post(url, data, config) {
    const headerParams = Object.assign(
      { 'Content-Type': 'application/x-www-form-urlencoded' },
      config
    )
    return new Promise((resolve, reject) => {
			// 使用系统自带fetch接口
      systemFetch.fetch({
        url: url,
        method: 'POST',
        data: data,
        header: headerParams,
        success: function(res) {
          const data = res.data
          if (typeof data === 'string') {
						console.log(data)
            resolve(JSON.parse(data))
          } else if (typeof data === 'object') {
            resolve(data)
          }
        },
        fail: function(error) {
          resolve(error)
        }
      })
    })
  }
}
var openAdSwitch = true  // 默认为可关闭
function getAdSwitchConfig(){
	// 这里要确定是否为生产环境
	let url = prodUrl+'/config/info' 
	sFetch.post(url,{miniAppFrom:'quick'}).then(rs=>{
		if(rs){
			openAdSwitch = rs.data.openAd
		}
	})
}
setTimeout(() => {
	getAdSwitchConfig()
}, 0);



const qgSdkTool = {
	// 传入h5sdk的 init函数，init函数返回vue实例
	// 废除
	qgSdkReady: function(init){
		return
	},
	/**
	 * set cookie  uuid && serviceToken
	 */
	qgSdkSetUserLoginInfo: function(){
		let data = window._global.getPubRecordInfo()
    if (data) {
      // 兼容 包壳快游戏
      let uuid = data.uuid
      let serviceToken = data.token
      // 设置cookies
      uuid && setCookie('uuid', uuid)
      serviceToken && setCookie('serviceToken', serviceToken)
      return
    }
	},
	/**
	 * 调起支付
	 * @param {*} cpOrder 
	 */
	qgPay: function(cpOrder,success,fail){
		qg.pay({
			orderInfo: cpOrder,
			success: success,
			fail: fail
		})
	},
	/**
	 * 
	 * @param {*} obj 
	 * obj.devAppId 
	 * obj.initADUrl
	 * obj.MIADS,
	 * obj.isLandscape
	 * obj.onclose Function
	 */
	qgShowAd: async function(obj){
		// console.log('qgShowAd call+++++++++++++++')
		console.log(JSON.stringify(obj))
		let devAppId = ''
		if(systemStorage){
			devAppId = systemStorage.getSync('GAME_DEV_APP_ID')
			console.log('storage.get => devAppId: '+devAppId)
			if(obj.devAppId && !devAppId){
				devAppId = obj.devAppId
			}
		}
		let data = window._global.getPubRecordInfo()
		let systemInfo = qg.getSystemInfoSync()
		const sendData = {
			imei: data.imei_md5, // 用户唯一标识
			version: data.version, // 版本
			from: 'mig2H5', // 当前广告环境
			debug: false, // 获取是否是测试
			devAppId: devAppId, // devAppId
			networkType: data.wifi_status ? -1 : 1, // 网络环境
			model:'',
			androidId:'',
			country:systemInfo.language,
			device:data.ua
		}
		if(obj.initADUrl){
			//这里必须写明使用的协议，不然会报错
			if(obj.initADUrl.substring(0,2)==='//'){
				obj.initADUrl = 'https:'+obj.initADUrl
			}
		}
		let url = obj.initADUrl || 'https://api.h5game.g.mi.com/stat/ad/getAdInfo'
		try{
			let rs = await sFetch.post(url,sendData)
			let adInfo = rs.data.info
			let para = {
				userDefined: true,
				data: {}
			}
			if (adInfo.adInfos[0]) {
				const isImage = (fileUrl) => {
					if (!fileUrl) return ''
					const fileUrlArray = fileUrl.split('.')
					const suffix = fileUrlArray.length && fileUrlArray[fileUrlArray.length - 1]
					const img = ['jpg', 'jepg', 'gif', 'png', 'webp']
					const video = ['mp4', 'avi', 'rmvb']
					if (img.includes(suffix)) {
						return true
					} else if (video.includes(suffix)) {
						return false
					}
				}
				try {
					// 跟互三那边的广告字段统一
					let adDetail = adInfo.adInfos[0]
					let imgUrls = adDetail.imgUrls || adDetail.imgurls || []
					let assets = []
					if (imgUrls.length > 0) {
						imgUrls.forEach(imgPath => {
							assets.push({
								url: imgPath,
								materialType: 1
							})
						})
					}
					// 如果videoUrl是图片的话，把它unshift到assets下
					if (isImage(adDetail.videoUrl)) {
						assets.unshift({url: adDetail.videoUrl, materialType: 1})
						// 为图片时映射到assets
						adDetail.assets = assets
					}
					adDetail.adStyle = obj.isLandscape ? 81 : 82
					delete adDetail.imgUrls
					// 是否可关闭
					let duration = adDetail.duration
					delete adDetail.duration
					adDetail.adControl = {
						duration: duration,
						closeable: openAdSwitch
					}
					// targetType
					if (adDetail.targetType === 1 || adDetail.targetType === 3) {
						adDetail.targetType = 1
					} else if (adDetail.targetType === 2 || adDetail.targetType === 4 || adDetail.targetType === 8) {
						adDetail.targetType = 2
					}
					// brand  = title
					if (adDetail.brand) {
						adDetail.brand = adDetail.title
					}
					para.data = adInfo
				} catch (e) {
					console.log(e)
				}
			} else {
				para.data.code = 1 // 使用互三打底的广告
			}
			console.log('初始化广告参数' + JSON.stringify(para))
			let ad = null
			try {
				ad = adService.createRewardedVideoAd(para)
			} catch (e) {
				console.log(e)
			}
			const idGroup = {
        udid: data.deviceInfo ? (data.deviceInfo.uaid || '') : '',
        oaid: data.deviceInfo ? (data.deviceInfo.oaid || '') : '',
        vaid: data.deviceInfo ? (data.deviceInfo.vaid || '') : '',
        aaid: data.deviceInfo ? (data.deviceInfo.aaid || '') : '',
        imei: data.imei_md5 || ''
      }
			let sendAdStatistic = function (type, adEx) {
				// type 值为 VIEW CLICK
				const sendData = {
					ex: adEx,
					...idGroup
				}
				if (adEx) {
					adEx && obj.MIADS && obj.MIADS.Report.sendReport(type, sendData)
					console.log('成功发送打点')
				}
			}
			ad.show().then(res => {
				let ex = ''
				if (para.data.code === 1) {
					statistic.sendStatistic(mainStore.state, {
						page: 'Sdk_ad',
						event: 'PV',
						items: {},
						extra: {
							ad_stage: 'get_ad_unsave'
						}
					})
				} else {
					ex = adInfo.adInfos[0].ex
					sendAdStatistic('VIEW', ex)
				}
			}).catch(e => {
				console.log('--播放失败----------')
				console.log(e)
			})
			ad.onclose = function (data) {
				// '(true 表示用户是在视频播放完以后关闭的视频，false 表示用户在视频播放过程中关闭了视频):' + data.isEnded)
				obj.onclose && obj.onclose(data)
			}
			ad.ontrack = function (res) {
				let ex = ''
				if (para.data.code === 0) {
					ex = adInfo.adInfos[0].ex
				}
				sendAdStatistic(res.eventType, ex)
			}
			return new Promise(resolve  => {
				resolve({state:true,type: para.data.code===1?'get_ad_unsave':'get_ad_success'}) 
			})
		}catch(err){
			return new Promise(resolve  => {
				resolve({state:false,type: '',msg:err})
			})
		}
	}
}
window.qgSdkTool = qgSdkTool